#pragma once

#include "concepts.hpp"
#include "bits/iterator_types.hpp"

namespace ReVolta {

    /* indirectly_writable */
    template<typename OUT, typename T>
    concept indirectly_writable =
        requires ( OUT && o, T && t ) {
            *o = forward<T>( t );
            forward<OUT>( o ) = forward<T>( t );
            const_cast<const iter_reference_t<OUT> &&>( *o ) = forward<T>( t );
            const_cast<const iter_reference_t<OUT> &&>( *forward<OUT>( o ) ) = forward<T>( t );
        }
    ;

    namespace Detail {

        template<typename I>
        concept IndirectlyReadableImpl =
            requires( const I iterator ) {
                typename iter_value_t<I>;
                typename iter_reference_t<I>;
                typename iter_rvalue_reference_t<I>;
                { *iterator } -> same_as<iter_reference_t<I>>;
            } &&
            common_reference_with<iter_reference_t<I> &&, iter_value_t<I> &> &&
            common_reference_with<iter_reference_t<I> &&, iter_rvalue_reference_t<I> &&> &&
            common_reference_with<iter_rvalue_reference_t<I> &&, const iter_value_t<I> &>
        ;

    }

    /* The concept indirectly_readable is modeled by types that are readable by applying operator*,
     * such as pointers, smart pointers, and input iterators. */
    template<typename I>
    concept indirectly_readable = Detail::IndirectlyReadableImpl<remove_cvref_t<I>>;

    /* Computes the common reference type of 'T'. This is the common reference type between its reference type and an lvalue reference to its value type. */
    template<indirectly_readable T>
    using iter_common_reference_t = common_reference_t<iter_reference_t<T>, iter_value_t<T> &>;

    namespace Detail {

        /* An integer-like type is an (possibly cv-qualified) integer type (except for cv bool) 
         * or an implementation-provided (not user-provided) class that behaves like an integer type, 
         * including all operators, implicit conversions, and 'numeric_limits' specializations. 
         * If an integer-like type only represents non-negative values, it is unsigned-integer-like, 
         * otherwise it is signed-integer-like. */
        /* TODO: Possibly more to be added by logical OR */
        template<typename T>
        concept is_signed_integer_like = signed_integral<T>;

    }

    template<typename I>
    concept weakly_incrementable = 
        movable<I> &&
        requires( I iterator ) {
            typename iter_difference_t<I>;
            requires Detail::is_signed_integer_like<iter_difference_t<I>>;
            { ++iterator } -> same_as<I &>;
            iterator++;
        }
    ;

    template<typename I>
    concept incrementable =
        regular<I> &&
        weakly_incrementable<I> &&
        requires( I i ) {
            { i++ } -> same_as<I>;
        }
    ;

    /* iterator concept */
    namespace Detail {

        template<typename I>
        struct iterator_concept_detector {};

        template<typename I>
            requires ( requires { typename iterator_traits<I>::iterator_concept; } )
        struct iterator_concept_detector<I> {
            using type = typename iterator_traits<I>::iterator_concept;
        };

        template<typename I>
            requires ( 
                !requires { typename iterator_traits<I>::iterator_concept; } &&
                 requires { typename iterator_traits<I>::iterator_category; }
            )
        struct iterator_concept_detector<I> {
            using type = typename iterator_traits<I>::iterator_category;
        };

        template<typename I>
            requires ( 
                !requires { typename iterator_traits<I>::iterator_concept; } &&
                !requires { typename iterator_traits<I>::iterator_category; }
                /* TODO: Check that iterator_traits<I> names a specialization generated by primary template */
            )
        struct iterator_concept_detector<I> {
            using type = random_access_iterator_tag;
        };

        template<typename I>
        using iterator_concept = typename Detail::iterator_concept_detector<I>::type;
    }

    template<typename I>
    concept input_or_output_iterator =
        weakly_incrementable<I> &&
        requires( I iterator ) {
            { *iterator };
        }
    ;

    template<typename I>
    concept input_iterator =
        input_or_output_iterator<I> &&
        indirectly_readable<I> &&
        requires { typename Detail::iterator_concept<I>; } &&
        derived_from<Detail::iterator_concept<I>, input_iterator_tag>
    ;

    template<typename I, typename T>
    concept output_iterator =
        input_or_output_iterator<I> &&
        indirectly_writable<I, T> &&
        requires( I iterator, T && t ) {
            *iterator++ = forward<T>( t );
        }
    ;

    template<typename S, typename I>
    concept sentinel_for =
        semiregular<S> &&
        input_or_output_iterator<I> &&
        Detail::WeaklyEqualityComparableWith<S, I>
    ;

    template<typename S, typename I>
    inline constexpr bool disable_sized_sentinel_for = false;

    template<typename S, typename I>
    concept sized_sentinel_for =
        sentinel_for<S, I> &&
        !disable_sized_sentinel_for<remove_cv_t<S>, remove_cv_t<I>> &&
        requires( const I & i, const S & s ) {
            { s - i } -> same_as<iter_difference_t<I>>;
            { i - s } -> same_as<iter_difference_t<I>>;
        }
    ;

    template<typename I>
    concept forward_iterator =
        input_iterator<I> &&
        derived_from<Detail::iterator_concept<I>, forward_iterator_tag> &&
        incrementable<I> &&
        sentinel_for<I, I>
    ;

    template<typename I>
    concept bidirectional_iterator =
        forward_iterator<I> &&
        derived_from<Detail::iterator_concept<I>, bidirectional_iterator_tag> &&
        requires( I i ) {
            { --i } -> same_as<I &>;
            { i-- } -> same_as<I>;
        }
    ;

    template<typename I>
    concept random_access_iterator =
        bidirectional_iterator<I> &&
        derived_from<Detail::iterator_concept<I>, random_access_iterator_tag> &&
        totally_ordered<I> &&
        sized_sentinel_for<I, I> &&
        requires( I i, const I j, const iter_difference_t<I> n ) {
            { i += n } -> same_as<I &>;
            { j +  n } -> same_as<I>;
            { n +  j } -> same_as<I>;
            { i -= n } -> same_as<I &>;
            { j -  n } -> same_as<I>;
            { j[ n ] } -> same_as<iter_reference_t<I>>;
        }
    ;
    
    template<typename I>
    concept contiguous_iterator = 
        random_access_iterator<I> &&
        derived_from<Detail::iterator_concept<I>, contiguous_iterator_tag> &&
        is_lvalue_reference_v<iter_reference_t<I>> &&
        same_as<iter_value_t<I>, remove_cvref_t<iter_reference_t<I>>> &&
        requires( const I & i ) {
            { to_address( i ) } -> same_as<add_pointer_t<iter_reference_t<I>>>;
        }
    ;

    /* The concept indirect_unary_predicate specifies requirements for algorithms that call unary predicates as their arguments. 
     * The key difference between this concept and std::predicate is that it is applied to the type that I references, 
     * rather than I itself. */
    template<class F, class I>
    concept indirect_unary_predicate =
        indirectly_readable<I> &&
        copy_constructible<F> &&
        predicate<F &, iter_value_t<I> &> &&
        predicate<F &, iter_reference_t<I>> &&
        predicate<F &, iter_common_reference_t<I>>;
}